/*
индексная страница http://localhost:8181/index
*/

package main

import (
	"BOT/brain"
	"BOT/brain/action_sensor"
	"BOT/brain/gomeostas"
	word_sensor "BOT/brain/words_sensor"
	"BOT/closer"
	"BOT/lib"
	"fmt"
	"log"
	"net/http"
	"strconv"
)

/* В проекте много глобальных переменных, что привычно раздражает Свидетелей инкапсуляции и непорочного пространства имен,
но ТАК НУЖНО (спорно) для одганизации среды,
схожей с организацией линкующих указателей в мозге (т.е. связей с одного распознавателя к целому ансаблю - объекту).
Ну и есть немало других вещей, нарушающих Порядок и Традиции Golang.
Попытки использовать горутины оказались просто неуместными (спорно) и просто ненужными, учитывая вряд ли в чем-то могущий быть выигрыш.
Короче, код предоставляется на вольное растерзание и свободное экспериментирование, без претензий, сорри за возможный негатив.
Везде много пространных комментариев, которые запутывают даже меня, но они НУЖНЫ.
*/

func receiveSend(resp http.ResponseWriter, r *http.Request) {
	resp.Header().Set("Access-Control-Allow-Origin", "*")
	resp.Header().Set("Access-Control-Allow-Headers", "Content-Type")
	if r.Method == "POST" {

// 	текстовый блок для набивки дерева слов-фраз из http://go/pages/words.php
		text_block := r.FormValue("text_block")
		if len(text_block) > 0 {
			res:=word_sensor.SetNewTextBlock(text_block)
			_, _ = fmt.Fprint(resp, res)
			return
		}
		////////////////////////////////////////////////////////

		text_dlg := r.FormValue("text_dlg")
		if len(text_dlg) > 0 {
			is_input_rejim,_:=strconv.Atoi(r.FormValue("is_input_rejim"))
			pult_mood := r.FormValue("pult_mood")
			moodID,_:=strconv.Atoi(pult_mood)
			res:=word_sensor.VerbalDetection(text_dlg,is_input_rejim,moodID)
			_, _ = fmt.Fprint(resp, res)
			return
		}

		// отправить на пульт состояние гомеостаза бота и его базовые контексты
		getParams := r.FormValue("get_params")
		if len(getParams) > 0 {
			outStr :=gomeostas.GetCurGomeoParams()

			outStr +="#|#"+gomeostas.GetCurGomeoStatus()+"#|#"+gomeostas.GetCurContextActive()
/*
			cntx,dominanta:=gomeostas.GetCurContextMap()
			//fmt.Println(cntx)
			outStr +="#|#"+cntx+"#|#"+dominanta
			//  ХУЖЕ-ЛУЧШЕ:
			//  fmt.Println("Состояние: ",brain.CurrentWellAndBadvalue," ХУЖЕ-ЛУЧШЕ: ",brain.DetectorWellAndBad," ВЕС ИЗМЕНЕНИЙ: ",brain.DetectorWellAndBadWeight);
			outStr +="#|#"+strconv.Itoa(brain.DetectorWellAndBad)
			// состояние периода доминирующего контекста (действие эмпатии
			outStr +="#|#"+strconv.Itoa(brain.IsDomContext)
			// список текущих активных рефлексов
			outStr +="#|#"+brain.ReflexesListActive
			// скорость потери энергии
			outStr +="#|#"+fmt.Sprintf("%10.1f",brain.SpeedEnergi)
			// текущие события - на консоль Пульта
			outStr +="#|#"+brain.WritePultConsolStr
			brain.WritePultConsolStr="" // обнулять переданный пакет
			// эмоция Бота:
			outStr +="#|#"+brain.GetBotEmotion()
			// последние эмпатийные события
			outStr +="#|#"+brain.StackEmpatiaActivnost
			if brain.LastActiveTreeNode!=nil{
				outStr +="#|#"+strconv.Itoa(brain.LastActiveTreeNode.ID) // 10-я переменная
			}else{
				outStr +="#|#0"
			}
			// список новых слов
			wStr:=brain.GetCurrentUnknownWords()
			if len(wStr)>0 {
				outStr += "#|#" + wStr // 11-я переменная
			}else{outStr +="#|#0"}
*/
			//fmt.Println(outStr)
			_, _ = fmt.Fprint(resp, outStr)
return
		}



		// установка параметров гомеостаза с Пульта:
		// задать параметры гомеостаза бота
		setParamsId := r.FormValue("set_params")
		if len(setParamsId) > 0 {
			id,_:=strconv.Atoi(setParamsId)
			gomeostas.SetCurGomeoParams(id,r.FormValue("params_val"))
			_, _ = fmt.Fprint(resp, "1")
			return
		}


// передача на Пульт сигнала готовности - когда нет других запросов - посылаетс сигнал на Пульт в function bot_answer(res)
		if word_sensor.IsReadyWordSensorLevel(){
			_, _ = fmt.Fprint(resp, "READY")
			return
		}

		_, _ = fmt.Fprint(resp, "POST")

	}
	//fmt.Println("EMPTY")

////////////////////////////////////////////////////////////////////////
	if r.Method == "GET" {
		get_phrase_tree := r.FormValue("get_phrase_tree")
		if get_phrase_tree=="1"{
			phTree:=word_sensor.GetPhraseTreeForPult()
if phTree == "!!!"{
	return // запрет показа карты во время распознавания и записи
}
			_, _ = fmt.Fprint(resp, phTree)
			return
		}
		////////////////////////////////////////////
		get_word_tree := r.FormValue("get_word_tree")
		if get_word_tree=="1"{
			phTree:=word_sensor.GetWordTreeForPult()
			if phTree == "!!!"{
				return // запрет показа карты во время распознавания и записи
			}
			_, _ = fmt.Fprint(resp, phTree)
			return
		}
		////////////////////////////////////////////
		set_action := r.FormValue("set_action")
		if len(set_action)>0{
			action,_:=strconv.Atoi(set_action)
			action_sensor.SetActionFromPult(action)
			_, _ = fmt.Fprint(resp, "!")
			return
		}
		_, _ = fmt.Fprint(resp, "GET")
	}

}

func init(){



	lib.GetMainPathExeFile()
	log.SetFlags(log.Lshortfile | log.LstdFlags)
}


func main() {
	// для перехвата при завершении программы (использует пакет "BOT/closer" https://github.com/xlab/closer):
	closer.Bind(cleanupFunc)
	/*
		go func() {// автоматическое закрытие через 10 секунд после запуска:
			// do some pseudo background work
			//fmt.Println("10 seconds to go...")
			//time.Sleep(10 * time.Second)
			//closer.Close()
		}()
	*/
	////////////////////////////////////////
	http.HandleFunc("/", receiveSend)
	_ = http.ListenAndServe("go:8181", nil)
	fmt.Println("Сервер запущен...")
////////////////////////////////////////////

	brain.RunInitialisation()// init.go
	brain.Puls()
	// gomeostas.LiveParams[0]=0

///////////////////////////////////////////
	// в самом конце
	closer.Hold()
}
/////////////////////////
func cleanupFunc() {
	fmt.Print("ПОСЛЕДНИЕ ДЕЙСТВИЯ ПЕРЕД ЗАКРЫВАНИЕМ ПРОГРАММЫ")
	// записать текущее состояние Дерева Моделей и Эпизодическую память
	//	brain.PrepareBeforCloseTreeModel()
	/* если внезапно откобчить мозг человека, то из памяти пропадет все, что было в последние полчаса
	так что просто записывать PrepareBeforCloseTreeModel() раз в 10 минут и при создании нового узла дерева
	*/
	gomeostas.SaveCurrentGomeoParams()
}
///////////////////////////////////////////////////////////////